#include "stdafx.h"
#include "inputclass.h"
#include "graphicsclass.h"
#include "TimerClass.h"
#include "PositionClass.h"
#include "systemclass.h"


SystemClass::SystemClass()
{
}


SystemClass::SystemClass(const SystemClass& other)
{
}


SystemClass::~SystemClass()
{
}


bool SystemClass::Initialize()
{
	//  â ,    ʱȭ
	int screenWidth = 0;
	int screenHeight = 0;

	//   ʱȭ
	InitializeWindows(screenWidth, screenHeight);

	// m_Input ü .  Ŭ   Ű Է ó ˴ϴ.
	m_Input = new InputClass;
	if (!m_Input)
	{
		return false;
	}

	// m_Input ü ʱȭ
	if(!m_Input->Initialize(m_hinstance, m_hwnd, screenWidth, screenHeight))
	{
		MessageBox(m_hwnd, L"Could not initialize the input object.", L"Error", MB_OK);
		return false;
	}

	// m_Graphics ü .  ׷  óϱ  üԴϴ.
	m_Graphics = new GraphicsClass;
	if (!m_Graphics)
	{
		return false;
	}

	// m_Graphics ü ʱȭ.
	if(!m_Graphics->Initialize(screenWidth, screenHeight, m_hwnd))
	{
		return false;
	}
	
	// Ÿ̸ ü ϴ.
	m_Timer = new TimerClass;
	if(!m_Timer)
	{
		return false;
	}

	// Ÿ̸ ü ʱȭմϴ.
	if(!m_Timer->Initialize())
	{
		MessageBox(m_hwnd, L"Could not initialize the Timer object.", L"Error", MB_OK);
		return false;
	}

	// ġ ü մϴ.
	m_Position = new PositionClass;
	if(!m_Position)
	{
		return false;
	}

	// Set the initial position of the viewer.
	m_Position->SetPosition(0.0f, 2.0f, -12.0f);

	return true;
}


void SystemClass::Shutdown()
{
	// ġ ü ȯ
	if(m_Position)
	{
		delete m_Position;
		m_Position = 0;
	}

	// Ÿ̸ ü մϴ.
	if(m_Timer)
	{
		delete m_Timer;
		m_Timer = 0;
	}

	// m_Graphics ü ȯ
	if (m_Graphics)
	{
		m_Graphics->Shutdown();
		delete m_Graphics;
		m_Graphics = 0;
	}

	// m_Input ü ȯ
	if (m_Input)
	{
		m_Input->Shutdown();
		delete m_Input;
		m_Input = 0;
	}

	// Window  ó
	ShutdownWindows();
}


void SystemClass::Run()
{
	// ޽ ü   ʱȭ
	MSG msg;
	ZeroMemory(&msg, sizeof(MSG));

	// ڷκ  ޽  ޽ ϴ
	while (true)
	{
		//  ޽ óմϴ
		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			//  ޽   ޽  Żմϴ
			if (msg.message == WM_QUIT)
				break;

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			//  ܿ Frame Լ óմϴ.
			if (!Frame())
			{
				MessageBox(m_hwnd, L"Frame Processing Failed", L"Error", MB_OK);
				break;
			}
		}
		
		// ڰ ESCŰ  Ȯ   ó
		if(m_Input->IsEscapePressed() == true)
		{
			break;
		}
	}
}


bool SystemClass::Frame()
{
	XMFLOAT3 position(0.0f, 0.0f, 0.0f);


	// Update the system stats.
	m_Timer->Frame();

	// Է  ó մϴ
	if(!m_Input->Frame())
	{
		return false;
	}

	// Ʈ  ġ ϱ   ð մϴ.
	m_Position->SetFrameTime(m_Timer->GetTime());

	//  Ǵ  ȭǥ Ű  ȮϽʽÿ. ׷  ī޶  ȸϽʽÿ.
	m_Position->MoveLeft(m_Input->IsLeftPressed());

	m_Position->MoveRight(m_Input->IsRightPressed());

	// Get the view point position/rotation.
	m_Position->GetPosition(position);

	// Do the frame processing for the graphics object.
	return m_Graphics->Frame(position);
}


LRESULT CALLBACK SystemClass::MessageHandler(HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam)
{
	return DefWindowProc(hwnd, umsg, wparam, lparam);
}


void SystemClass::InitializeWindows(int& screenWidth, int& screenHeight)
{
	// ܺ ͸  ü մϴ
	ApplicationHandle = this;

	//  α׷ νϽ ɴϴ
	m_hinstance = GetModuleHandle(NULL);

	// α׷ ̸ մϴ
	m_applicationName = L"Dx11Demo_34";

	// windows Ŭ Ʒ  մϴ.
	WNDCLASSEX wc;
	wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = m_hinstance;
	wc.hIcon = LoadIcon(NULL, IDI_WINLOGO);
	wc.hIconSm = wc.hIcon;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = m_applicationName;
	wc.cbSize = sizeof(WNDCLASSEX);

	// windows class մϴ
	RegisterClassEx(&wc);

	//  ȭ ػ󵵸 оɴϴ
	screenWidth = GetSystemMetrics(SM_CXSCREEN);
	screenHeight = GetSystemMetrics(SM_CYSCREEN);

	int posX = 0;
	int posY = 0;

	// FULL_SCREEN    ȭ մϴ.
	if (FULL_SCREEN)
	{
		// Ǯũ  ߴٸ  ȭ ػ󵵸 ũ ػ󵵷 ϰ  32bit մϴ.
		DEVMODE dmScreenSettings;
		memset(&dmScreenSettings, 0, sizeof(dmScreenSettings));
		dmScreenSettings.dmSize = sizeof(dmScreenSettings);
		dmScreenSettings.dmPelsWidth = (unsigned long)screenWidth;
		dmScreenSettings.dmPelsHeight = (unsigned long)screenHeight;
		dmScreenSettings.dmBitsPerPel = 32;
		dmScreenSettings.dmFields = DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT;

		// Ǯũ ÷  մϴ.
		ChangeDisplaySettings(&dmScreenSettings, CDS_FULLSCREEN);
	}
	else
	{
		//    800 * 600 ũ⸦ մϴ.
		screenWidth = 800;
		screenHeight = 600;

		//  â ,     մϴ.
		posX = (GetSystemMetrics(SM_CXSCREEN) - screenWidth) / 2;
		posY = (GetSystemMetrics(SM_CYSCREEN) - screenHeight) / 2;
	}

	// 츦 ϰ ڵ մϴ.
	m_hwnd = CreateWindowEx(WS_EX_APPWINDOW, m_applicationName, m_applicationName,
		WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_POPUP,
		posX, posY, screenWidth, screenHeight, NULL, NULL, m_hinstance, NULL);

	// 츦 ȭ鿡 ǥϰ Ŀ մϴ
	ShowWindow(m_hwnd, SW_SHOW);
	SetForegroundWindow(m_hwnd);
	SetFocus(m_hwnd);
}


void SystemClass::ShutdownWindows()
{
	// Ǯũ 忴ٸ ÷  ʱȭմϴ.
	if (FULL_SCREEN)
	{
		ChangeDisplaySettings(NULL, 0);
	}

	// â մϴ
	DestroyWindow(m_hwnd);
	m_hwnd = NULL;

	// α׷ νϽ մϴ
	UnregisterClass(m_applicationName, m_hinstance);
	m_hinstance = NULL;

	// ܺ  ʱȭմϴ
	ApplicationHandle = NULL;
}


LRESULT CALLBACK WndProc(HWND hwnd, UINT umessage, WPARAM wparam, LPARAM lparam)
{
	switch (umessage)
	{
		//  Ḧ Ȯմϴ
	case WM_DESTROY:
	{
		PostQuitMessage(0);
		return 0;
	}

	// 찡  Ȯմϴ
	case WM_CLOSE:
	{
		PostQuitMessage(0);
		return 0;
	}

	//    ޽ ý Ŭ ޽ ó ѱϴ.
	default:
	{
		return ApplicationHandle->MessageHandler(hwnd, umessage, wparam, lparam);
	}
	}
}